%define _unpackaged_files_terminate_build 0

Summary: cups-filters
Name: cups-filters
Version: 1.0.36_2
Release: 1
License: GPL-2.0+ and MIT
Group: System Environment/Daemons
Source0: %{name}-%{version}.tar.gz
Source1001: cups-filters.manifest
Source1002: libcupsfilters1.manifest
Source1003: libfontembed.manifest
Url: http://www.cups.org
Patch1: tizen-pdftoraster-oom-fix.patch
Patch2: tizen_fix_ignore_sigpipe.patch

Requires(post): glibc
Requires: libcupsfilters1
#used only for texttopdf
#Requires: libfontembed
BuildRequires:  cups
BuildRequires:  pkgconfig(poppler)
#BuildRequires:  pkgconfig(poppler-cpp)
BuildRequires:  pkgconfig(lcms2)
BuildRequires:  pkgconfig(libpng)
BuildRequires:  pkgconfig(fontconfig)
BuildRequires:  pkgconfig(ijs)
#BuildRequires:  xpdf-tools
BuildRequires:  libjpeg-turbo-devel
BuildRequires:  libtiff-devel
BuildRequires:  zlib-devel
BuildRequires:  cups-devel
BuildRequires:  cups-libs
BuildRequires:  pkgconfig(gnutls)
BuildRequires:  pkgconfig(libqpdf)
BuildRequires:  which
BuildRequires:  libgcrypt-devel

%description
This package provides the CUPS shared libraries.

%package -n libcupsfilters1
Summary: CUPS - shared libraries
Group: System Environment/Libraries
Requires: cups
Provides: libcupsfilters1

%description -n libcupsfilters1
This package provides the CUPS shared libraries.

%package -n libfontembed
Summary: CUPS - shared libraries
Group: System Environment/Libraries
Requires: cups
Provides: libfontembed

%description -n libfontembed
This package provides library which contains functions for font embedding in PDF files, commonly
 used by CUPS filters.

%package -n libfontembed-devel
Summary: CUPS - shared libraries
Group: System Environment/Libraries
Requires: cups
Provides: libfontembed-devel

%description -n libfontembed-devel
This package provides the headers and development environment for libfontembed library.

%package -n libcupsfilters-devel
Summary: CUPS - shared libraries
Group: System Environment/Libraries

%description -n libcupsfilters-devel
This package provides the CUPS headers and development environment.

%prep
%setup -q
cp %{SOURCE1001} .
cp %{SOURCE1002} .
cp %{SOURCE1003} .
# OOM can be happened in using pdftoraster, becuase 600dpi use huge memory(about 1.6G)
# This patch fixes pdftoraster to use about 400M in 600dpi printing.
%patch1 -p1
# CUPS daemon is launced and exited frequently
# Fixed that pdftoraster ignore SIGPIPE
%patch2 -p1

%build

export GC_SECTIONS_FLAGS="-fdata-sections -ffunction-sections -Wl,--gc-sections"
export CFLAGS+=" ${GC_SECTIONS_FLAGS} -Wvariadic-macros"
export CXXFLAGS+=" ${GC_SECTIONS_FLAGS} -fpermissive -Wvariadic-macros"

./autogen.sh
%configure \
     --prefix=/usr --mandir=/usr/share/man --without-tiff --without-php \
     --enable-imagefilters --with-jpeg --with-png \
     --enable-largefile \
     --with-pdftops=pdftops

BUILDROOT=$RPM_BUILD_ROOT DESTDIR=$RPM_BUILD_ROOT DSTROOT=$RPM_BUILD_ROOT make -Ioprs -Iopvp -I../opvp -I. -I.. -I/usr/include/poppler -I/usr/include/ijs -I/usr/include/poppler/splash

%install
%make_install

mkdir -p %{buildroot}/usr/share/license
cp %{_builddir}/%{buildsubdir}/COPYING %{buildroot}/usr/share/license/%{name}
cp %{_builddir}/%{buildsubdir}/COPYING %{buildroot}/usr/share/license/libcupsfilters1
cp %{_builddir}/%{buildsubdir}/COPYING %{buildroot}/usr/share/license/libfontembed

%post -n libfontembed -p /sbin/ldconfig

%post -n libcupsfilters1 -p /sbin/ldconfig

%postun -n libfontembed -p /sbin/ldconfig

%postun -n libcupsfilters1 -p /sbin/ldconfig

%files
%manifest cups-filters.manifest
/usr/share/license/%{name}
%exclude /etc/fonts/conf.d/99pdftoopvp.conf
%exclude %{_libdir}/cups/backend/*
%attr(0755,root,root) %dir /usr/lib/cups/filter
%{_libdir}/cups/filter/*
%exclude %{_libdir}/cups/filter/texttopdf
%exclude %{_libdir}/cups/filter/textonly
%exclude %{_libdir}/cups/filter/texttops
%exclude %{_libdir}/cups/filter/commandtoescpx
%exclude %{_libdir}/cups/filter/commandtopclx
%exclude %{_libdir}/cups/filter/rastertoescpx
%exclude %{_libdir}/cups/filter/rastertopclx
%exclude %{_libdir}/cups/filter/pdftoijs
%exclude %{_libdir}/cups/filter/pdftoopvp
%exclude %{_libdir}/cups/filter/gstopxl
%exclude %{_libdir}/cups/filter/gstoraster
%exclude %{_docdir}/cups-filters/*
%exclude /etc/rc0.d/*
%exclude /etc/rc2.d/*
%exclude /etc/rc3.d/*
%exclude /etc/rc5.d/*
%exclude %{_bindir}/ttfread
%exclude /usr/share/ppd/*
%dir /usr/share/cups
/usr/share/cups/*

%files -n libfontembed 
%manifest libfontembed.manifest
/usr/share/license/libfontembed
%{_libdir}/libfontembed.so.*

%files -n libfontembed-devel
%{_libdir}/libfontembed.so
#%{_libdir}/libcupsfilters.a
%{_libdir}/pkgconfig/libfontembed.pc
%{_includedir}/fontembed/*.h

%files -n libcupsfilters1
%manifest libcupsfilters1.manifest
/usr/share/license/libcupsfilters1
%{_libdir}/libcupsfilters.so.*

%files -n libcupsfilters-devel
%{_libdir}/libcupsfilters.so
%{_libdir}/pkgconfig/libcupsfilters.pc
%{_includedir}/cupsfilters/*.h
